#ifndef	_PTPCOMMON_H
#define	_PTPCOMMON_H

#include <linux/types.h>
#include <asm/byteorder.h>


#if defined(__LITTLE_ENDIAN_BITFIELD)
	#define ROUTE_CHANGE 0x80000000
	#define COUNTER_OVERFLOW 0x40000000

#elif defined(__BIG_ENDIAN_BITFIELD)
	#define ROUTE_CHANGE 0x00000001
	#define COUNTER_OVERFLOW 0x00000002
#else
#error  "Adjust your <asm/byteorder.h> defines"
#endif




struct ptpmsg {
	__u32   rci;
	__u32	mib2_ifspeed;
	__u32	traffic;
};

#ifdef	__DEBUG
	#define	_DMSG0(format)				fprintf(stderr, format);
	#define	_DMSG1(format, arg1)			fprintf(stderr, format, arg1);
	#define	_DMSG2(format, arg1, arg2)		fprintf(stderr, format, arg1, arg2);
	#define	_DMSG3(format, arg1, arg2, arg3)	fprintf(stderr, format, arg1, arg2, arg3);
#else
	#define	_DMSG0(format)
	#define	_DMSG1(format, arg1)
	#define	_DMSG2(format, arg1, arg2)
	#define	_DMSG3(format, arg1, arg2, arg3)
#endif

#define	PTP_PROTO				123
#define	PTP_DEFAULT_PORT			0
#define	PTP_DEFAULT_TTL				64

// the various PTP content types
#define	PTP_TYPE_IFMTU				0x00
#define	PTP_TYPE_IFSPEED			0x01
#define	PTP_TYPE_ADDR_IFSPEED			0x02
#define	PTP_TYPE_ADDR_TIME_IFOCTETS		0x03
#define	PTP_TYPE_ADDR_TIME_IFSPEED_IFOCTETS	0x04

#define	IP_OPTION_ROUTER_ALERT			0x9404	// IP-option, router alert on

#endif
